
var VnObject = require('./object');
var Type = require('./type');
var ParamIface = require('./param-iface');
var LotIface = require('./lot-iface');

/**
 * A simple implementation of @ParamIface.
 */
module.exports = new Class({
	Extends: VnObject
	,Implements: ParamIface
	,Tag: 'vn-param'
	,Properties: {
		value: {
			type: null
			,set(x) {
				this._setValue(x);
			}
			,get() {
				return this._value;
			}
		},
		type: {
			type: Type
			,set(x) {
				this._setType(x);
			}
			,get() {
				return this._type;
			}
		},
		param: {
			type: ParamIface
			,set(x) {
				this._setParam(x);
			}
			,get() {
				return this._param;
			}
		},
		master: {
			type: ParamIface
			,set(x) {
				this._setParam(x);
			}
			,get() {
				return this._param;
			}
		},
		lot: {
			type: LotIface
			,set(x) {
				this._setLot(x);
			}
			,get() {
				return this._lot;
			}
		},
		name: {
			type: String
			,set(x) {
				this._setName(x);
			}
			,get() {
				return this._name;
			}
		},
		oneWay: {
			type: Boolean
			,set(x) {
				this._oneWay = x;
			}
			,get() {
				return this._oneWay;
			}
		},
		oneTime: {
			type: Boolean
			,set(x) {
				this._oneTime = x;
			}
			,get() {
				return this._oneTime;
			}
		}
	}
});
